; Appendix 5\dance_tb.lsp
;  N.Poleshchuk, 2006
; Based on the book: N.Poleshchuk, P.Loskutov
;"AutoLISP and Visual LISP Inside AutoCAD"
; ("BHV-Petersburg" Publishing House, 2006)
;
; Listing 3. File dance_tb.lsp
;

(defun dance_tb (tb plist ntime / wbOK p x0 y0 x1 y1)
(if (and (listp plist)(> (vl-list-length plist) 0))
  (progn
    (setq plist (vl-remove-if-not 'test plist))
    (setq x0 (vla-get-Left tb) y0 (vla-get-Top tb))
    (while plist
      (setq x1 (caar plist) y1 (cadar plist))
      (move_tb tb x0 y0 x1 y1 ntime)
      (setq x0 x1 y0 y1 plist (cdr plist))
    );while plist
  );progn
);if
);defun dance_tb
  
; Checking whether list has 2 elements and they both are numbers (numberp)
; Additional function
(defun test (p / wbOK)
  (setq wbOK (if (and (listp p) (= (vl-list-length p) 2)) T nil))
  (if wbOK
    (setq wbOK (and (numberp (car p)) (numberp (cadr p))))
  );if
);defun test    (returns T only for valid list)
