;  5\move_tb.lsp
;  N.Poleshchuk, 2006
; Based on the book: N.Poleshchuk, P.Loskutov
;"AutoLISP and Visual LISP Inside AutoCAD"
; ("BHV-Petersburg" Publishing House, 2006)
;
; Listing 2. File move_tb.lsp
;

(defun move_tb (tb x1 y1 x2 y2 ntime / i x y)
(vla-Float tb x1 y1 1)
(setq i 0 x x1 y y1)
(repeat ntime
  (setq i (1+ i) x (+ x1 (/ (/ (* i (- x2 x1)) ntime))))
  (setq y (+ y1 (/ (/ (* i (- y2 y1)) ntime))))
  (vla-put-Left tb x)
  (vla-put-Top tb y)
);repeat
(vlr-beep-reaction)
);defun move_tb
